enum MessageTypeEnum {
	placeHolder_0,
	Connection,
	Disconnect,
	Notify,
	KeepNotify,
	Ask,
	Ack,
}

enum NotificationTypeEnum {
	placeHolder_0,
	Message,
	Action,
	Update,
	NotifyRecordCodesMessage,
	FinishNotifyRecordsMessage,
}

class NotifyMessage {
	int length;
	MessageTypeEnum messageType;
	NotificationTypeEnum notificationType;
	String? message;

	NotifyMessage({
		this.length = 0,
		this.messageType = MessageTypeEnum.Connection,
		this.notificationType = NotificationTypeEnum.Message,
		this.message,
	});

	factory NotifyMessage.fromJson(Map<String, dynamic> map) {
		return NotifyMessage( 
			length: map['Length'],
			messageType: MessageTypeEnum.values.firstWhere((e) => e.index == map['MessageType']),
			notificationType: NotificationTypeEnum.values.firstWhere((e) => e.index == map['NotificationType']),
			message: map['Message'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['Length'] = length;
		map['MessageType'] = messageType.index;
		map['NotificationType'] = notificationType.index;
		if(message != null)
			map['Message'] = message;
		return map;
	}
}

class SendNotificationRequest {
	String? clientId;
	NotifyMessage? message;

	SendNotificationRequest({
		this.clientId,
		this.message,
	});

	factory SendNotificationRequest.fromJson(Map<String, dynamic> map) {
		return SendNotificationRequest( 
			clientId: map['ClientId'],
			message: map['Message'] != null ? NotifyMessage.fromJson(map['Message']) : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if(clientId != null)
			map['ClientId'] = clientId;
		if(message != null)
			map['Message'] = message;
		return map;
	}
}


